function createInfoBox(d, title) {
	if (d.getElementById('ext-pi-container') == null) {
		// Container div
		var container = d.createElement('div');
		container.id = 'ext-pi-container';
		
		container.innerHTML = 
			'<ul id="ext-pi-tabs">\
				<li class="current"><a id="ext-pi-tab-reviews" href="#reviews"><b>Reviews</b></a></li>\
			</ul>\
			<div id="ext-pi-content">\
				<p id="ext-pi-movie-title">Searching ' + title + '...</p>\
				<img id="ext-pi-loading" style="margin: 2em 0;" src="chrome://pi/skin/ajax-loader.gif" />\
				<p id="ext-pi-rating"></p>\
				<p id="ext-pi-info"></p>\
				<p><a href="#wrong-movie" id="ext-pi-wrong-movie">Wrong movie?</a></p>\
			</div>';
		var target = xFetch1("//td[@class='blh']//ancestor::*[7]", d); //CHANGED!
		target.parentNode.insertBefore(container, target);
		// Listen for wrong movie click
		(d.getElementById('ext-pi-wrong-movie')).addEventListener(
			'click',
			function() {
				pi_XHR.throwError(d, 'You wanted to try to find a movie other than');
				pi_Logger.log('Title is = ' + pi_XHR._title);
			},
			false);

		// Event listener for tabs
		(d.getElementById('ext-pi-tab-reviews')).addEventListener('click', function() { toggleInfo(d, 'block'); }, false);
	} else {
		var c = d.getElementById('ext-pi-container');
		c.parentNode.removeChild(c);
		createInfoBox(d, title);
	}
}

 /**
  * @author http://kevin.vanzonneveld.net
	* @param array
	*/
function array_diff(array) {
	var arr_dif = [], i = 1, argc = arguments.length, argv = arguments, key, key_c, found=false;

	// loop through 1st array
	for ( key in array ){
			// loop over other arrays
			for (i = 1; i< argc; i++){
					// find in the compare array
					found = false
					for (key_c in argv[i]) {
							if (argv[i][key_c] == array[key]) {
									found = true;
									break;
							}
					}
					if(!found){
							arr_dif[key] = array[key];
					}
			}
	}
	return arr_dif;
}

function trim(text) {
	text = String(text);
	return text.replace(/^\s+|\s+$/g,"");
}

function xFetch(xpath, doc) {
	// Evaluate xpath
	var nodes = doc.evaluate(xpath, doc.body, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	 
	// Prepare result array
	var result = new Array(nodes.snapshotLength);

	// Iterate results
	for (var x=0; x<result.length; x++) {
		result[x] = nodes.snapshotItem(x);
	}

	return result;
}

function xFetch1(xpath, doc) {
	// Evaluate xpath
	var node = doc.evaluate(xpath, doc.body, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
	return node.singleNodeValue;
}

function toggleInfo(d, display) {
	var i, items = d.getElementById('ext-pi-content').getElementsByTagName('p');
	
	if (display == 'block') { // Reviews
		if (d.getElementById('ext-pi-trailer-object')) {
			var t = d.getElementById('ext-pi-content');
			t.removeChild(d.getElementById('ext-pi-trailer-object'));
			t.parentNode.style.width = '350px';
		}
		d.getElementById('ext-pi-tab-reviews').parentNode.className = 'current';
		d.getElementById('ext-pi-tab-trailer').parentNode.className = null;
	} else { // Trailer
		d.getElementById('ext-pi-tab-reviews').parentNode.className = null;
		d.getElementById('ext-pi-tab-trailer').parentNode.className = 'current';
		d.getElementById('ext-pi-container').style.width = '510px';
	}
	
	// "display" items
	for (i=0;i<items.length;i++) {
		items[i].style.display = display;
	}
}

function strip(text) {
	return text.replace(/(\<(\/?[^\>]+)\>)/gi,'');
}