var piDialog = {
  onPageLoad: function (e) {
    var doc = e.originalTarget;  // Doc that triggered onLoad
    
    // Grab prefs
    var piPrefs = Components.classes["@mozilla.org/preferences-service;1"].
      getService(Components.interfaces.nsIPrefBranch);

    doc.getElementById('highlight-check').checked = piPrefs.getBoolPref("extensions.pi.highlight.enabled");
    doc.getElementById('search-check').checked = piPrefs.getBoolPref("extensions.pi.searchhelper.enabled");
    doc.getElementById('flames-check').checked = piPrefs.getBoolPref("extensions.pi.highlight.flames");
    doc.getElementById('rt-check').checked = piPrefs.getBoolPref("extensions.pi.searchhelper.site.rottentomatoes");
    doc.getElementById('imdb-check').checked = piPrefs.getBoolPref("extensions.pi.searchhelper.site.imdb");
    doc.getElementById('trailer-check').checked = piPrefs.getBoolPref("extensions.pi.searchhelper.trailer.enabled");
    doc.getElementById('popular-value').value = piPrefs.getIntPref("extensions.pi.highlight.popular");
    doc.getElementById('text-color-choice').color = piPrefs.getCharPref("extensions.pi.highlight.textColor");
    doc.getElementById('row-color-choice').color = piPrefs.getCharPref("extensions.pi.highlight.rowColor");
		// If rowcolor or textcolor were disabled, set to 'none'
		doc.getElementById('text-color-disable').checked = (piPrefs.getCharPref("extensions.pi.highlight.textColor") == 'none') ? true : false;
		doc.getElementById('row-color-disable').checked = (piPrefs.getCharPref("extensions.pi.highlight.rowColor") == 'none') ? true : false;
    
    // If our main settings are false, disable their group
    if (!piPrefs.getBoolPref("extensions.pi.highlight.enabled")) {
      toggleHighlight(false);
    }
    if (!piPrefs.getBoolPref("extensions.pi.searchhelper.enabled")) {
      toggleSearch(false);
    }		
  }
};

// Event listener
window.addEventListener("load", function(e) { piDialog.onPageLoad(e); }, false);

function acceptSettings () {
  // Shortcut
  var doc = document;

  // Grab prefs
  var piPrefs = Components.classes["@mozilla.org/preferences-service;1"].
    getService(Components.interfaces.nsIPrefBranch);
  
  // Throw this in a try block in case there is an error
  // This will enable the user to still close the settings dialog
  try {
    // save our prefs
    piPrefs.setBoolPref("extensions.pi.highlight.enabled", doc.getElementById('highlight-check').checked);
    piPrefs.setBoolPref("extensions.pi.highlight.flames", doc.getElementById('flames-check').checked);
    piPrefs.setBoolPref("extensions.pi.searchhelper.site.rottentomatoes", doc.getElementById('rt-check').checked);
    piPrefs.setBoolPref("extensions.pi.searchhelper.site.imdb", doc.getElementById('imdb-check').checked);
    piPrefs.setBoolPref("extensions.pi.searchhelper.trailer.enabled", doc.getElementById('trailer-check').checked);
		
		// If rowcolor or textcolor were disabled, set to 'none'
		var tc = (doc.getElementById('text-color-disable').checked) ? 'none' : doc.getElementById('text-color-choice').color;
		var rc = (doc.getElementById('row-color-disable').checked) ? 'none' : doc.getElementById('row-color-choice').color;		
		piPrefs.setCharPref("extensions.pi.highlight.textColor", tc);
    piPrefs.setCharPref("extensions.pi.highlight.rowColor", rc);
    
    // Check if the popular value was greater than 0, otherwise the highlighting will error
    if (doc.getElementById('popular-value').value < 1) {
      throw "popular";
    } else {
      piPrefs.setIntPref("extensions.pi.highlight.popular", doc.getElementById('popular-value').value);
    }
    
    // If search is enabled, but all search options are unchecked, then set search helper to false
    // This prevents a blank box from being drawn
    if (!doc.getElementById('rt-check').checked && !doc.getElementById('imdb-check').checked && !doc.getElementById('trailer-check').checked) {
      piPrefs.setBoolPref("extensions.pi.searchhelper.enabled", false);
    } else {
      piPrefs.setBoolPref("extensions.pi.searchhelper.enabled", doc.getElementById('search-check').checked);
    }
    
    return true;
  } catch (err) {
    if (err == "popular") {
      alert('Popular value must be greater than 0, try again');
      return false;
    } else {
      alert('Error = ' + err.description + '\nPlease contact noon via IRC or private message with this error.');
      return true;
    }
  }
}

function toggleSearch(o) {
  if (o) {
    document.getElementById('rt-check').disabled = false;
    document.getElementById('imdb-check').disabled = false;
    document.getElementById('trailer-check').disabled = false;
  } else {
    document.getElementById('rt-check').disabled = true;
    document.getElementById('imdb-check').disabled = true;
    document.getElementById('trailer-check').disabled = true;
  }
}

function toggleHighlight(o) {
  if (o) {
  document.getElementById('popular-value').disabled = false;
  document.getElementById('flames-check').disabled = false;
  document.getElementById('text-color-choice').disabled = false;
  document.getElementById('row-color-choice').disabled = false;
  } else {
  document.getElementById('popular-value').disabled = true;
  document.getElementById('flames-check').disabled = true;
  document.getElementById('text-color-choice').disabled = true;
  document.getElementById('row-color-choice').disabled = true;
  }
}